#ifndef __DERIVED_H
#define __DERIVED_H

#include <stdint.h>
#include <iostream>
#include <new>
#include <sstream>
#include <string>

#include "Pd_Index.h"

template <typename _Key, typename _Value>
class Pd_HashtableIndex : public Pd_Index<_Key, _Value> { 
    public:

        /** 
         * @class ConstIterator 
         */

        class ConstIterator : public virtual Pd_Index<_Key, _Value>::ConstIterator
        {
            public:
                /**
                 * @brief Construct a ConstIterator
                 */

                ConstIterator (const Pd_HashtableIndex <_Key, _Value>* hashindex, size_t hash_code) {}
                /** @copydoc Pd_Index::ConstIterator::~ConstIterator() */
                virtual ~ConstIterator () {}

                /** @copydoc Pd_Index::ConstIterator::Begin() */
                virtual void Begin() 
                {
                    std::cerr << "Pd_HashtableIndex::ConstIterator::Begin ()" << std::endl;
                }

        };

        /** 
         * @class Iterator
         */

        class Iterator : public Pd_HashtableIndex<_Key, _Value>::ConstIterator, public Pd_Index<_Key, _Value>::Iterator
        {
            public:
                /**
                 * @brief Construct an Iterator 
                 */

                Iterator (Pd_HashtableIndex <_Key, _Value>* hashindex, size_t hash_code) : Pd_HashtableIndex<_Key, _Value>::ConstIterator (hashindex, hash_code) {}
                /** @copydoc Pd_Index::Iterator::~Iterator() */
                virtual ~Iterator () {}
        };

};

#endif
